<?php
    /* ------------------------------------------
     * INITIALIZE DATABASE
     * ------------------------------------------ */
    include 'config.inc';
    include 'opendb.inc';
    
    /* ------------------------------------------
     * INITIALIZE SESSION
     * ------------------------------------------ */
	//initialize session
    if (strlen(session_id()) == 0){
    	session_start();
    }// end if

    // ----------------------------------------
	// initialize showhints session and cookie 
	// ----------------------------------------
	/* This code is here to create a simulated vulnerability. Some
	 * sites put authorication and status tokens in cookies instead
	 * of the session. This is a mistake. The user controls the 
	 * cookies entirely.
	 */
	if (isset($_COOKIE["showhints"])){
		$l_showhints_cookie = $_COOKIE["showhints"];
	}else{
		$l_showhints_cookie = 0;
	}// end if
	
	if ($l_showhints_cookie){
		$_SESSION["hints-enabled"] = "Enabled";
		$_SESSION["showhints"] = TRUE;
	}else{	
		$_SESSION["hints-enabled"] = "Disabled";
		$_SESSION["showhints"] = FALSE;
	}//end if
    
    // initialize security level to "insecure"
    if (!isset($_SESSION['security-level'])){
    	$_SESSION['security-level'] = '0';
    }// end if
    
	// user is logged out by default
    if (!isset($_SESSION["loggedin"])){
	    $_SESSION['loggedin'] = 'False';
	    $_SESSION['logged_in_user'] = '';
	    $_SESSION['logged_in_usersignature'] = '';	    	
    }// end if    
    
    if (!isset($_SESSION["hints-enabled"])){
    	$_SESSION["hints-enabled"] = "Disabled";
    }// end if
    	    
	//initialize OWASP ESAPI for PHP
    require_once './owasp-esapi-php/src/ESAPI.php';
	if (!isset($ESAPI)){
		$ESAPI = new ESAPI('./owasp-esapi-php/src/ESAPI.xml');
		$Encoder = $ESAPI->getEncoder();
	}// end if
	
	//initialize custom error handler
    require_once './classes/CustomErrorHandler.php';
	if (!isset($CustomErrorHandler)){
		$CustomErrorHandler = 
		new CustomErrorHandler("/owasp-esapi-php/src/", $_SESSION["security-level"]);
	}// end if	

    /* ------------------------------------------
     * REACT TO CLIENT SIDE CHANGES
     * ------------------------------------------ */
	switch ($_SESSION["security-level"]){
   		case "0": // This code is insecure
			/* Use the clients authorization token which is stored in
			 * the cookie (in this case). Placing authorization tokens
			 * on the client is fairly ridiculous.
			 * 
			 * Known Vulnerabilities: SQL Injection, Authorization Bypass, Session Fixation,
			 * 	Lack of custom error page, Application Exception
			 */
   			if (isset($_COOKIE['uid'])){
			    try {	    	
					$query  = "SELECT * FROM accounts WHERE cid='" . $_COOKIE['uid'] . "'";
					$result = mysql_query($query);
					if (mysql_errno()>0){
				    	throw (new Exception('Error: '.mysql_error($conn).'<br /><br />', mysql_errno()));
				    }// end if

				    // Switch to whatever cookie the user sent to simulate sites
				    // that use client-side authorization tokens. Auth information
				    // should never be in cookies.
				    if (mysql_num_rows($result) > 0) {
					    $row = mysql_fetch_array($result, MYSQL_ASSOC);
						$_SESSION['loggedin'] = 'True';
						$_SESSION['uid'] = $row['cid'];
						$_SESSION['logged_in_user'] = $row['username'];
						$_SESSION['logged_in_usersignature'] = $row['mysignature'];
   						header('Logged-In-User: '.$_SESSION['logged_in_user'], true);
			    	}// end if (mysql_num_rows($result) > 0)
				    
				} catch (Exception $e) {
			   		echo $CustomErrorHandler->FormatError($e, $query); 
			   	}// end try
   			}else{
	   			/* 
	   			 * Output the user's login name into a custom header 
	   			 * 
	   			 * Known Vulnerability: Potential HTTP Response Splitting
	   			 * (PHP defends itself against HTTP response splitting by
	   			 * filtering "new line" characters)
	   			 */
   				header('Logged-In-User: '.$_SESSION['logged_in_user'], true);
   			}// end if
     			
   		break;
	    		
   		case "5": // This code is fairly secure
  			/* If we are secure, then we do not rely on any client input
  			 * to make authorization decisions. Authorization tokens should
  			 * never be stored on the client. We use the SESSION in secure mode.
  			 * 
  			 * Also, when we create an HTTP header, we encode any output to 
  			 * prevent response splitting. The critical chars in response splitting
  			 * are CR-LF. Dont fall for filtering. Just encoding it all.  			
  			 */
   			header('Logged-In-User: '.$Encoder->encodeForHTML($_SESSION['logged_in_user']), true);
   		break;
   	}// end switch		
	
	/* ------------------------------------------
     * PROCESS REQUESTS
     * ------------------------------------------ */
    // Get the value of the "page" URL query parameter
    if (isset($_GET["page"])) {
    	$page = $_GET["page"];
    }else{
    	$page = "";
    }// end if
	
	if (isset($_GET["do"])){
    	include ("/process-commands.php");
    }// end if
    
    // detect and process login attempt
    if (isset($_POST["login-php-submit-button"])){
    	include ("/process-login-attempt.php");
    }// end if

    /* ------------------------------------------
     * DISPLAY PAGE
     * ------------------------------------------ */
    // always include header
    include ("/header.php");

    if (strlen($page)==0 || !isset($page)){
	    include("/home.htm");
	    include("/homenotes.php");
    } else { 
	    include ($page); 
    }// end if

    // always include footer
    include ("/footer.php");
?>